package exercises.ex_q1;

import java.util.concurrent.ExecutionException;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledExecutorService;

public class Pizzeria {
    public static void main(String[] args) throws ExecutionException, InterruptedException {
        ScheduledExecutorService executor = Executors.newSingleThreadScheduledExecutor();
        Pizzaiolo marco = new Pizzaiolo("Marco");
        Pizzaiolo antonio = new Pizzaiolo("Antonio");

        Future<Pizza> future1 = executor.submit(marco);
        Future<Pizza> future2 = executor.submit(antonio);
        Future<Pizza> future3 = executor.submit(marco);
        Future<Pizza> future4 = executor.submit(antonio);

        marco.serve(future1.get());
        antonio.serve(future2.get());
        marco.serve(future3.get());
        antonio.serve(future4.get());

        executor.shutdown();
    }
}
