package exercises.ex_r;

public class Postman implements Runnable {
    private PostOffice office;

    public Postman(PostOffice office) {
        this.office = office;
    }

    @Override
    public void run() {
        while (true) {
            try {
                Package pkg = office.takePackage();
                Thread.sleep((long) (1000L + 2000L * Math.random()));
                System.out.println("Delivered " + pkg);
            } catch (InterruptedException e) {
                break;
            }
        }
    }
}
