package exercises.ex_s3;

import java.util.List;

public class User implements Runnable {
    private final String name;
    private final List<AbstractTweet> tweets;

    public User(String name, List<AbstractTweet> tweets) {
        this.name = name;
        this.tweets = tweets;
    }

    @Override
    public void run() {
        for (int i = 0; i < 100000; i++) {
            if (i % 10 == 9) {
                tweets.forEach(AbstractTweet::removeLike);
            } else {
                tweets.forEach(AbstractTweet::addLike);
            }
        }
    }
}
