package exercises.ex_x;

import java.util.concurrent.Phaser;

public class TestingPhaserFamilyBikeTrip {
    public static void main(String[] args) {
        String[] family = {"Father", "Mother", "Son", "Daughter_1", "Daughter_2"};
        String[] routes = {"Sierre", "Sion", "Martigny", "St-Maurice", "Aigle", "Vevey"};
        Phaser phaser = new Phaser();
        phaser.register();

        System.out.println("The family leaves Brig for a bike trip to Vevey");
        for (int i = 0; i < family.length; i++) {
            new Thread(new FamilyMember(family[i], phaser, routes.length)).start();
        }

        for (int i = 0; i < routes.length; i++) {
            phaser.arriveAndAwaitAdvance();
            System.out.println("All family members arrived to " + routes[i]);
        }
        phaser.arriveAndDeregister();
        System.out.println("End of the bike trip.");
    }
}
