package exercises.ex_p_bis;

public class Light {
    private boolean isOn = false;
    private String prefix = "";
    private static final String suffix = Ansi.RESET;
    private ChristmasTree tree;

    public Light(String prefix) {
        this.prefix = prefix;
    }

    public void toggle() {
        isOn = !isOn;
        tree.show();
    }

    public void setTree(ChristmasTree tree) {
        this.tree = tree;
    }

    public String apply(String c) {
        if (isOn) {
            return c;
        }
        if (c.equals(" ")) {
            c = "⬤";
        }
        return prefix + c + suffix;
    }
}
