package exercises.ex_v;

import java.util.Comparator;
import java.util.List;

public class Referee implements Runnable {
    private final List<Result> results;

    public Referee(List<Result> results) {
        this.results = results;
    }

    @Override
    public void run() {
        System.out.println("Referee starts to establish ranking...");
        results.sort(Result::compareTo);
        System.out.println("PDG Team Ranking:");
        results.forEach(System.out::println);
    }
}
