package exercises.ex_y;

import java.util.concurrent.Phaser;

public class RaceTester {
    public static final int NUM_RUNNERS = 10;
    public static final int NUM_STAGES = 5;

    public static void main(String[] args) throws InterruptedException {
        Phaser phaser = new Phaser();
        phaser.register();
        for (int i = 0; i < NUM_RUNNERS; i++) {
            new Thread(new Runner(NUM_STAGES, phaser)).start();
        }
        for (int i = 0; i <= NUM_STAGES; i++) {
            phaser.arriveAndAwaitAdvance();
        }
        System.out.println("Finished race");
        phaser.arriveAndDeregister();
    }
}
